Gnome XML Library Reference Manual
<<< Previous Page | Home | Up | Next Page >>>

# parser

## Name

parser --

## Synopsis

    #define     XML_DEFAULT_VERSION
    void        (*xmlParserInputDeallocate)     (xmlChar *str);
    struct      xmlParserInput;
    struct      xmlParserNodeInfo;
    typedef     xmlParserNodeInfoPtr;
    struct      xmlParserNodeInfoSeq;
    typedef     xmlParserNodeInfoSeqPtr;
    enum        xmlParserInputState;
    #define     XML_DETECT_IDS
    #define     XML_COMPLETE_ATTRS
    #define     XML_SKIP_IDS
    struct      xmlParserCtxt;
    struct      xmlSAXLocator;
    xmlParserInputPtr (*resolveEntitySAXFunc)   (void *ctx,
                                                 const xmlChar *publicId,
                                                 const xmlChar *systemId);
    void        (*internalSubsetSAXFunc)        (void *ctx,
                                                 const xmlChar *name,
                                                 const xmlChar *ExternalID,
                                                 const xmlChar *SystemID);
    void        (*externalSubsetSAXFunc)        (void *ctx,
                                                 const xmlChar *name,
                                                 const xmlChar *ExternalID,
                                                 const xmlChar *SystemID);
    xmlEntityPtr (*getEntitySAXFunc)            (void *ctx,
                                                 const xmlChar *name);
    xmlEntityPtr (*getParameterEntitySAXFunc)   (void *ctx,
                                                 const xmlChar *name);
    void        (*entityDeclSAXFunc)            (void *ctx,
                                                 const xmlChar *name,
                                                 int type,
                                                 const xmlChar *publicId,
                                                 const xmlChar *systemId,
                                                 xmlChar *content);
    void        (*notationDeclSAXFunc)          (void *ctx,
                                                 const xmlChar *name,
                                                 const xmlChar *publicId,
                                                 const xmlChar *systemId);
    void        (*attributeDeclSAXFunc)         (void *ctx,
                                                 const xmlChar *elem,
                                                 const xmlChar *fullname,
                                                 int type,
                                                 int def,
                                                 const xmlChar *defaultValue,
                                                 xmlEnumerationPtr tree);
    void        (*elementDeclSAXFunc)           (void *ctx,
                                                 const xmlChar *name,
                                                 int type,
                                                 xmlElementContentPtr content);
    void        (*unparsedEntityDeclSAXFunc)    (void *ctx,
                                                 const xmlChar *name,
                                                 const xmlChar *publicId,
                                                 const xmlChar *systemId,
                                                 const xmlChar *notationName);
    void        (*setDocumentLocatorSAXFunc)    (void *ctx,
                                                 xmlSAXLocatorPtr loc);
    void        (*startDocumentSAXFunc)         (void *ctx);
    void        (*endDocumentSAXFunc)           (void *ctx);
    void        (*startElementSAXFunc)          (void *ctx,
                                                 const xmlChar *name,
                                                 const xmlChar **atts);
    void        (*endElementSAXFunc)            (void *ctx,
                                                 const xmlChar *name);
    void        (*attributeSAXFunc)             (void *ctx,
                                                 const xmlChar *name,
                                                 const xmlChar *value);
    void        (*referenceSAXFunc)             (void *ctx,
                                                 const xmlChar *name);
    void        (*charactersSAXFunc)            (void *ctx,
                                                 const xmlChar *ch,
                                                 int len);
    void        (*ignorableWhitespaceSAXFunc)   (void *ctx,
                                                 const xmlChar *ch,
                                                 int len);
    void        (*processingInstructionSAXFunc) (void *ctx,
                                                 const xmlChar *target,
                                                 const xmlChar *data);
    void        (*commentSAXFunc)               (void *ctx,
                                                 const xmlChar *value);
    void        (*cdataBlockSAXFunc)            (void *ctx,
                                                 const xmlChar *value,
                                                 int len);
    void        (*warningSAXFunc)               (void *ctx,
                                                 const char *msg,
                                                 ...);
    void        (*errorSAXFunc)                 (void *ctx,
                                                 const char *msg,
                                                 ...);
    void        (*fatalErrorSAXFunc)            (void *ctx,
                                                 const char *msg,
                                                 ...);
    int         (*isStandaloneSAXFunc)          (void *ctx);
    int         (*hasInternalSubsetSAXFunc)     (void *ctx);
    int         (*hasExternalSubsetSAXFunc)     (void *ctx);
    struct      xmlSAXHandler;
    xmlParserInputPtr (*xmlExternalEntityLoader)
                                                (const char *URL,
                                                 const char *ID,
                                                 xmlParserCtxtPtr context);
    void        xmlInitParser                   (void);
    void        xmlCleanupParser                (void);
    int         xmlParserInputRead              (xmlParserInputPtr in,
                                                 int len);
    int         xmlParserInputGrow              (xmlParserInputPtr in,
                                                 int len);
    xmlChar*    xmlStrdup                       (const xmlChar *cur);
    xmlChar*    xmlStrndup                      (const xmlChar *cur,
                                                 int len);
    xmlChar*    xmlCharStrndup                  (const char *cur,
                                                 int len);
    xmlChar*    xmlCharStrdup                   (const char *cur);
    xmlChar*    xmlStrsub                       (const xmlChar *str,
                                                 int start,
                                                 int len);
    const xmlChar* xmlStrchr                    (const xmlChar *str,
                                                 xmlChar val);
    const xmlChar* xmlStrstr                    (const xmlChar *str,
                                                 const xmlChar *val);
    const xmlChar* xmlStrcasestr                (const xmlChar *str,
                                                 xmlChar *val);
    int         xmlStrcmp                       (const xmlChar *str1,
                                                 const xmlChar *str2);
    int         xmlStrncmp                      (const xmlChar *str1,
                                                 const xmlChar *str2,
                                                 int len);
    int         xmlStrcasecmp                   (const xmlChar *str1,
                                                 const xmlChar *str2);
    int         xmlStrncasecmp                  (const xmlChar *str1,
                                                 const xmlChar *str2,
                                                 int len);
    int         xmlStrEqual                     (const xmlChar *str1,
                                                 const xmlChar *str2);
    int         xmlStrlen                       (const xmlChar *str);
    xmlChar*    xmlStrcat                       (xmlChar *cur,
                                                 const xmlChar *add);
    xmlChar*    xmlStrncat                      (xmlChar *cur,
                                                 const xmlChar *add,
                                                 int len);
    xmlDocPtr   xmlParseDoc                     (xmlChar *cur);
    xmlDocPtr   xmlParseMemory                  (const char *buffer,
                                                 int size);
    xmlDocPtr   xmlParseFile                    (const char *filename);
    int         xmlSubstituteEntitiesDefault    (int val);
    int         xmlKeepBlanksDefault            (int val);
    void        xmlStopParser                   (xmlParserCtxtPtr ctxt);
    int         xmlPedanticParserDefault        (int val);
    int         xmlLineNumbersDefault           (int val);
    xmlDocPtr   xmlRecoverDoc                   (xmlChar *cur);
    xmlDocPtr   xmlRecoverMemory                (const char *buffer,
                                                 int size);
    xmlDocPtr   xmlRecoverFile                  (const char *filename);
    int         xmlParseDocument                (xmlParserCtxtPtr ctxt);
    int         xmlParseExtParsedEnt            (xmlParserCtxtPtr ctxt);
    xmlDocPtr   xmlSAXParseDoc                  (xmlSAXHandlerPtr sax,
                                                 xmlChar *cur,
                                                 int recovery);
    int         xmlSAXUserParseFile             (xmlSAXHandlerPtr sax,
                                                 void *user_data,
                                                 const char *filename);
    int         xmlSAXUserParseMemory           (xmlSAXHandlerPtr sax,
                                                 void *user_data,
                                                 const char *buffer,
                                                 int size);
    xmlDocPtr   xmlSAXParseMemory               (xmlSAXHandlerPtr sax,
                                                 const char *buffer,
                                                 int size,
                                                 int recovery);
    xmlDocPtr   xmlSAXParseMemoryWithData       (xmlSAXHandlerPtr sax,
                                                 const char *buffer,
                                                 int size,
                                                 int recovery,
                                                 void *data);
    xmlDocPtr   xmlSAXParseFile                 (xmlSAXHandlerPtr sax,
                                                 const char *filename,
                                                 int recovery);
    xmlDocPtr   xmlSAXParseFileWithData         (xmlSAXHandlerPtr sax,
                                                 const char *filename,
                                                 int recovery,
                                                 void *data);
    xmlDocPtr   xmlSAXParseEntity               (xmlSAXHandlerPtr sax,
                                                 const char *filename);
    xmlDocPtr   xmlParseEntity                  (const char *filename);
    xmlDtdPtr   xmlParseDTD                     (const xmlChar *ExternalID,
                                                 const xmlChar *SystemID);
    xmlDtdPtr   xmlSAXParseDTD                  (xmlSAXHandlerPtr sax,
                                                 const xmlChar *ExternalID,
                                                 const xmlChar *SystemID);
    xmlDtdPtr   xmlIOParseDTD                   (xmlSAXHandlerPtr sax,
                                                 xmlParserInputBufferPtr input,
                                                 xmlCharEncoding enc);
    int         xmlParseBalancedChunkMemory     (xmlDocPtr doc,
                                                 xmlSAXHandlerPtr sax,
                                                 void *user_data,
                                                 int depth,
                                                 const xmlChar *string,
                                                 xmlNodePtr *lst);
    int         xmlParseBalancedChunkMemoryRecover
                                                (xmlDocPtr doc,
                                                 xmlSAXHandlerPtr sax,
                                                 void *user_data,
                                                 int depth,
                                                 const xmlChar *string,
                                                 xmlNodePtr *lst,
                                                 int recover);
    int         xmlParseExternalEntity          (xmlDocPtr doc,
                                                 xmlSAXHandlerPtr sax,
                                                 void *user_data,
                                                 int depth,
                                                 const xmlChar *URL,
                                                 const xmlChar *ID,
                                                 xmlNodePtr *lst);
    int         xmlParseCtxtExternalEntity      (xmlParserCtxtPtr ctx,
                                                 const xmlChar *URL,
                                                 const xmlChar *ID,
                                                 xmlNodePtr *lst);
    void        xmlInitParserCtxt               (xmlParserCtxtPtr ctxt);
    void        xmlClearParserCtxt              (xmlParserCtxtPtr ctxt);
    void        xmlFreeParserCtxt               (xmlParserCtxtPtr ctxt);
    void        xmlSetupParserForBuffer         (xmlParserCtxtPtr ctxt,
                                                 const xmlChar *buffer,
                                                 const char *filename);
    xmlParserCtxtPtr xmlCreateDocParserCtxt     (xmlChar *cur);
    int         xmlGetFeaturesList              (int *len,
                                                 const char **result);
    int         xmlGetFeature                   (xmlParserCtxtPtr ctxt,
                                                 const char *name,
                                                 void *result);
    int         xmlSetFeature                   (xmlParserCtxtPtr ctxt,
                                                 const char *name,
                                                 void *value);
    xmlParserCtxtPtr xmlCreatePushParserCtxt    (xmlSAXHandlerPtr sax,
                                                 void *user_data,
                                                 const char *chunk,
                                                 int size,
                                                 const char *filename);
    int         xmlParseChunk                   (xmlParserCtxtPtr ctxt,
                                                 const char *chunk,
                                                 int size,
                                                 int terminate);
    xmlParserCtxtPtr xmlCreateIOParserCtxt      (xmlSAXHandlerPtr sax,
                                                 void *user_data,
                                                 xmlInputReadCallback ioread,
                                                 xmlInputCloseCallback ioclose,
                                                 void *ioctx,
                                                 xmlCharEncoding enc);
    xmlParserInputPtr xmlNewIOInputStream       (xmlParserCtxtPtr ctxt,
                                                 xmlParserInputBufferPtr input,
                                                 xmlCharEncoding enc);
    const xmlParserNodeInfo* xmlParserFindNodeInfo
                                                (const xmlParserCtxtPtr ctxt,
                                                 const xmlNodePtr node);
    void        xmlInitNodeInfoSeq              (xmlParserNodeInfoSeqPtr seq);
    void        xmlClearNodeInfoSeq             (xmlParserNodeInfoSeqPtr seq);
    unsigned long xmlParserFindNodeInfoIndex    (const xmlParserNodeInfoSeqPtr seq,
                                                 const xmlNodePtr node);
    void        xmlParserAddNodeInfo            (xmlParserCtxtPtr ctxt,
                                                 const xmlParserNodeInfoPtr info);
    void        xmlSetExternalEntityLoader      (xmlExternalEntityLoader f);
    xmlExternalEntityLoader xmlGetExternalEntityLoader
                                                (void);
    xmlParserInputPtr xmlLoadExternalEntity     (const char *URL,
                                                 const char *ID,
                                                 xmlParserCtxtPtr ctxt);

## Description

## Details

### XML_DEFAULT_VERSION

    #define     XML_DEFAULT_VERSION

The default version of XML used: 1.0

### xmlParserInputDeallocate ()

    void        (*xmlParserInputDeallocate)     (xmlChar *str);

Callback for freeing some parser input allocations.

`str` : |

### struct xmlParserInput

    struct xmlParserInput {
        /* Input buffer */
        xmlParserInputBufferPtr buf;      /* UTF-8 encoded buffer */

        const char *filename;             /* The file analyzed, if any */
        const char *directory;            /* the directory/base of the file */
        const xmlChar *base;              /* Base of the array to parse */
        const xmlChar *cur;               /* Current char being parsed */
        const xmlChar *end;               /* end of the array to parse */
        int length;                       /* length if known */
        int line;                         /* Current line */
        int col;                          /* Current column */
        int consumed;                     /* How many xmlChars already consumed */
        xmlParserInputDeallocate free;    /* function to deallocate the base */
        const xmlChar *encoding;          /* the encoding string for entity */
        const xmlChar *version;           /* the version string for entity */
        int standalone;                   /* Was that entity marked standalone */
    };

An xmlParserInput is an input flow for the XML processor. Each entity parsed is associated an xmlParserInput (except the few predefined ones). This is the case both for internal entities - in which case the flow is already completely in memory - or external entities - in which case we use the buf structure for progressive reading and I18N conversions to the internal UTF-8 format.

### struct xmlParserNodeInfo

    struct xmlParserNodeInfo {
      const struct _xmlNode* node;
      /* Position & line # that text that created the node begins & ends on */
      unsigned long begin_pos;
      unsigned long begin_line;
      unsigned long end_pos;
      unsigned long end_line;
    };

The parser can be asked to collect Node informations, i.e. at what place in the file they were detected. NOTE: This is off by default and not very well tested.

### xmlParserNodeInfoPtr

### struct xmlParserNodeInfoSeq

    struct xmlParserNodeInfoSeq {
      unsigned long maximum;
      unsigned long length;
      xmlParserNodeInfo* buffer;
    };

### xmlParserNodeInfoSeqPtr

### enum xmlParserInputState

    typedef enum {
        XML_PARSER_EOF = -1,	/* nothing is to be parsed */
        XML_PARSER_START = 0,	/* nothing has been parsed */
        XML_PARSER_MISC,		/* Misc* before int subset */
        XML_PARSER_PI,		/* Within a processing instruction */
        XML_PARSER_DTD,		/* within some DTD content */
        XML_PARSER_PROLOG,		/* Misc* after internal subset */
        XML_PARSER_COMMENT,		/* within a comment */
        XML_PARSER_START_TAG,	/* within a start tag */
        XML_PARSER_CONTENT,		/* within the content */
        XML_PARSER_CDATA_SECTION,	/* within a CDATA section */
        XML_PARSER_END_TAG,		/* within a closing tag */
        XML_PARSER_ENTITY_DECL,	/* within an entity declaration */
        XML_PARSER_ENTITY_VALUE,	/* within an entity value in a decl */
        XML_PARSER_ATTRIBUTE_VALUE,	/* within an attribute value */
        XML_PARSER_SYSTEM_LITERAL,	/* within a SYSTEM value */
        XML_PARSER_EPILOG, 		/* the Misc* after the last end tag */
        XML_PARSER_IGNORE,		/* within an IGNORED section */
        XML_PARSER_PUBLIC_LITERAL 	/* within a PUBLIC value */
    } xmlParserInputState;

The parser is now working also as a state based parser. The recursive one use the state info for entities processing.

### XML_DETECT_IDS

    #define     XML_DETECT_IDS

Bit in the loadsubset context field to tell to do ID/REFs lookups. Use it to initialize xmlLoadExtDtdDefaultValue.

### XML_COMPLETE_ATTRS

    #define     XML_COMPLETE_ATTRS

Bit in the loadsubset context field to tell to do complete the elements attributes lists with the ones defaulted from the DTDs. Use it to initialize xmlLoadExtDtdDefaultValue.

### XML_SKIP_IDS

    #define     XML_SKIP_IDS

Bit in the loadsubset context field to tell to not do ID/REFs registration. Used to initialize xmlLoadExtDtdDefaultValue in some special cases.

### struct xmlParserCtxt

    struct xmlParserCtxt {
        struct _xmlSAXHandler *sax;       /* The SAX handler */
        void            *userData;        /* For SAX interface only, used by DOM build */
        xmlDocPtr           myDoc;        /* the document being built */
        int            wellFormed;        /* is the document well formed */
        int       replaceEntities;        /* shall we replace entities ? */
        const xmlChar    *version;        /* the XML version string */
        const xmlChar   *encoding;        /* the declared encoding, if any */
        int            standalone;        /* standalone document */
        int                  html;        /* an HTML(1)/Docbook(2) document */

        /* Input stream stack */
        xmlParserInputPtr  input;         /* Current input stream */
        int                inputNr;       /* Number of current input streams */
        int                inputMax;      /* Max number of input streams */
        xmlParserInputPtr *inputTab;      /* stack of inputs */

        /* Node analysis stack only used for DOM building */
        xmlNodePtr         node;          /* Current parsed Node */
        int                nodeNr;        /* Depth of the parsing stack */
        int                nodeMax;       /* Max depth of the parsing stack */
        xmlNodePtr        *nodeTab;       /* array of nodes */

        int record_info;                  /* Whether node info should be kept */
        xmlParserNodeInfoSeq node_seq;    /* info about each node parsed */

        int errNo;                        /* error code */

        int     hasExternalSubset;        /* reference and external subset */
        int             hasPErefs;        /* the internal subset has PE refs */
        int              external;        /* are we parsing an external entity */

        int                 valid;        /* is the document valid */
        int              validate;        /* shall we try to validate ? */
        xmlValidCtxt        vctxt;        /* The validity context */

        xmlParserInputState instate;      /* current type of input */
        int                 token;        /* next char look-ahead */

        char           *directory;        /* the data directory */

        /* Node name stack */
        xmlChar           *name;          /* Current parsed Node */
        int                nameNr;        /* Depth of the parsing stack */
        int                nameMax;       /* Max depth of the parsing stack */
        xmlChar *         *nameTab;       /* array of nodes */

        long               nbChars;       /* number of xmlChar processed */
        long            checkIndex;       /* used by progressive parsing lookup */
        int             keepBlanks;       /* ugly but ... */
        int             disableSAX;       /* SAX callbacks are disabled */
        int               inSubset;       /* Parsing is in int 1/ext 2 subset */
        xmlChar *          intSubName;    /* name of subset */
        xmlChar *          extSubURI;     /* URI of external subset */
        xmlChar *          extSubSystem;  /* SYSTEM ID of external subset */

        /* xml:space values */
        int *              space;         /* Should the parser preserve spaces */
        int                spaceNr;       /* Depth of the parsing stack */
        int                spaceMax;      /* Max depth of the parsing stack */
        int *              spaceTab;      /* array of space infos */

        int                depth;         /* to prevent entity substitution loops */
        xmlParserInputPtr  entity;        /* used to check entities boundaries */
        int                charset;       /* encoding of the in-memory content
    				         actually an xmlCharEncoding */
        int                nodelen;       /* Those two fields are there to */
        int                nodemem;       /* Speed up large node parsing */
        int                pedantic;      /* signal pedantic warnings */
        void              *_private;      /* For user data, libxml won't touch it */

        int                loadsubset;    /* should the external subset be loaded */
        int                linenumbers;   /* set line number in element content */
        void              *catalogs;       /* document's own catalog */
        int                recovery;      /* run in recovery mode */
    };

The parser context. NOTE This doesn't completely define the parser state, the (current ?) design of the parser uses recursive function calls since this allow and easy mapping from the production rules of the specification to the actual code. The drawback is that the actual function call also reflect the parser state. However most of the parsing routines takes as the only argument the parser context pointer, so migrating to a state based parser for progressive parsing shouldn't be too hard.

### struct xmlSAXLocator

    struct xmlSAXLocator {
        const xmlChar *(*getPublicId)(void *ctx);
        const xmlChar *(*getSystemId)(void *ctx);
        int (*getLineNumber)(void *ctx);
        int (*getColumnNumber)(void *ctx);
    };

A SAX Locator.

### resolveEntitySAXFunc ()

    xmlParserInputPtr (*resolveEntitySAXFunc)   (void *ctx,
                                                 const xmlChar *publicId,
                                                 const xmlChar *systemId);

Callback: The entity loader, to control the loading of external entities, the application can either: - override this resolveEntity() callback in the SAX block - or better use the xmlSetExternalEntityLoader() function to set up it's own entity resolution routine

`ctx` : |
`publicId` : |
`systemId` : |
Returns : |

### internalSubsetSAXFunc ()

    void        (*internalSubsetSAXFunc)        (void *ctx,
                                                 const xmlChar *name,
                                                 const xmlChar *ExternalID,
                                                 const xmlChar *SystemID);

Callback on internal subset declaration.

`ctx` : |
`name` : |
`ExternalID` : |
`SystemID` : |

### externalSubsetSAXFunc ()

    void        (*externalSubsetSAXFunc)        (void *ctx,
                                                 const xmlChar *name,
                                                 const xmlChar *ExternalID,
                                                 const xmlChar *SystemID);

Callback on external subset declaration.

`ctx` : |
`name` : |
`ExternalID` : |
`SystemID` : |

### getEntitySAXFunc ()

    xmlEntityPtr (*getEntitySAXFunc)            (void *ctx,
                                                 const xmlChar *name);

Get an entity by name.

`ctx` : |
`name` : |
Returns : |

### getParameterEntitySAXFunc ()

    xmlEntityPtr (*getParameterEntitySAXFunc)   (void *ctx,
                                                 const xmlChar *name);

Get a parameter entity by name.

`ctx` : |
`name` : |
Returns : |

### entityDeclSAXFunc ()

    void        (*entityDeclSAXFunc)            (void *ctx,
                                                 const xmlChar *name,
                                                 int type,
                                                 const xmlChar *publicId,
                                                 const xmlChar *systemId,
                                                 xmlChar *content);

An entity definition has been parsed.

`ctx` : |
`name` : |
`type` : |
`publicId` : |
`systemId` : |
`content` : |

### notationDeclSAXFunc ()

    void        (*notationDeclSAXFunc)          (void *ctx,
                                                 const xmlChar *name,
                                                 const xmlChar *publicId,
                                                 const xmlChar *systemId);

What to do when a notation declaration has been parsed.

`ctx` : |
`name` : |
`publicId` : |
`systemId` : |

### attributeDeclSAXFunc ()

    void        (*attributeDeclSAXFunc)         (void *ctx,
                                                 const xmlChar *elem,
                                                 const xmlChar *fullname,
                                                 int type,
                                                 int def,
                                                 const xmlChar *defaultValue,
                                                 xmlEnumerationPtr tree);

An attribute definition has been parsed.

`ctx` : |
`elem` : |
`fullname` : |
`type` : |
`def` : |
`defaultValue` : |
`tree` : |

### elementDeclSAXFunc ()

    void        (*elementDeclSAXFunc)           (void *ctx,
                                                 const xmlChar *name,
                                                 int type,
                                                 xmlElementContentPtr content);

An element definition has been parsed.

`ctx` : |
`name` : |
`type` : |
`content` : |

### unparsedEntityDeclSAXFunc ()

    void        (*unparsedEntityDeclSAXFunc)    (void *ctx,
                                                 const xmlChar *name,
                                                 const xmlChar *publicId,
                                                 const xmlChar *systemId,
                                                 const xmlChar *notationName);

What to do when an unparsed entity declaration is parsed.

`ctx` : |
`name` : |
`publicId` : |
`systemId` : |
`notationName` : |

### setDocumentLocatorSAXFunc ()

    void        (*setDocumentLocatorSAXFunc)    (void *ctx,
                                                 xmlSAXLocatorPtr loc);

Receive the document locator at startup, actually xmlDefaultSAXLocator. Everything is available on the context, so this is useless in our case.

`ctx` : |
`loc` : |

### startDocumentSAXFunc ()

    void        (*startDocumentSAXFunc)         (void *ctx);

Called when the document start being processed.

`ctx` : |

### endDocumentSAXFunc ()

    void        (*endDocumentSAXFunc)           (void *ctx);

Called when the document end has been detected.

`ctx` : |

### startElementSAXFunc ()

    void        (*startElementSAXFunc)          (void *ctx,
                                                 const xmlChar *name,
                                                 const xmlChar **atts);

Called when an opening tag has been processed.

`ctx` : |
`name` : |
`atts` : |

### endElementSAXFunc ()

    void        (*endElementSAXFunc)            (void *ctx,
                                                 const xmlChar *name);

Called when the end of an element has been detected.

`ctx` : |
`name` : |

### attributeSAXFunc ()

    void        (*attributeSAXFunc)             (void *ctx,
                                                 const xmlChar *name,
                                                 const xmlChar *value);

Handle an attribute that has been read by the parser. The default handling is to convert the attribute into an DOM subtree and past it in a new xmlAttr element added to the element.

`ctx` : |
`name` : |
`value` : |

### referenceSAXFunc ()

    void        (*referenceSAXFunc)             (void *ctx,
                                                 const xmlChar *name);

Called when an entity reference is detected.

`ctx` : |
`name` : |

### charactersSAXFunc ()

    void        (*charactersSAXFunc)            (void *ctx,
                                                 const xmlChar *ch,
                                                 int len);

Receiving some chars from the parser.

`ctx` : |
`ch` : |
`len` : |

### ignorableWhitespaceSAXFunc ()

    void        (*ignorableWhitespaceSAXFunc)   (void *ctx,
                                                 const xmlChar *ch,
                                                 int len);

Receiving some ignorable whitespaces from the parser. UNUSED: by default the DOM building will use characters.

`ctx` : |
`ch` : |
`len` : |

### processingInstructionSAXFunc ()

    void        (*processingInstructionSAXFunc) (void *ctx,
                                                 const xmlChar *target,
                                                 const xmlChar *data);

A processing instruction has been parsed.

`ctx` : |
`target` : |
`data` : |

### commentSAXFunc ()

    void        (*commentSAXFunc)               (void *ctx,
                                                 const xmlChar *value);

A comment has been parsed.

`ctx` : |
`value` : |

### cdataBlockSAXFunc ()

    void        (*cdataBlockSAXFunc)            (void *ctx,
                                                 const xmlChar *value,
                                                 int len);

Called when a pcdata block has been parsed.

`ctx` : |
`value` : |
`len` : |

### warningSAXFunc ()

    void        (*warningSAXFunc)               (void *ctx,
                                                 const char *msg,
                                                 ...);

Display and format a warning messages, callback.

`ctx` : |
`msg` : |
`...` : |

### errorSAXFunc ()

    void        (*errorSAXFunc)                 (void *ctx,
                                                 const char *msg,
                                                 ...);

Display and format an error messages, callback.

`ctx` : |
`msg` : |
`...` : |

### fatalErrorSAXFunc ()

    void        (*fatalErrorSAXFunc)            (void *ctx,
                                                 const char *msg,
                                                 ...);

Display and format fatal error messages, callback. Note: so far fatalError() SAX callbacks are not used, error() get all the callbacks for errors.

`ctx` : |
`msg` : |
`...` : |

### isStandaloneSAXFunc ()

    int         (*isStandaloneSAXFunc)          (void *ctx);

Is this document tagged standalone?

`ctx` : |
Returns : |

### hasInternalSubsetSAXFunc ()

    int         (*hasInternalSubsetSAXFunc)     (void *ctx);

Does this document has an internal subset.

`ctx` : |
Returns : |

### hasExternalSubsetSAXFunc ()

    int         (*hasExternalSubsetSAXFunc)     (void *ctx);

Does this document has an external subset?

`ctx` : |
Returns : |

### struct xmlSAXHandler

    struct xmlSAXHandler {
        internalSubsetSAXFunc internalSubset;
        isStandaloneSAXFunc isStandalone;
        hasInternalSubsetSAXFunc hasInternalSubset;
        hasExternalSubsetSAXFunc hasExternalSubset;
        resolveEntitySAXFunc resolveEntity;
        getEntitySAXFunc getEntity;
        entityDeclSAXFunc entityDecl;
        notationDeclSAXFunc notationDecl;
        attributeDeclSAXFunc attributeDecl;
        elementDeclSAXFunc elementDecl;
        unparsedEntityDeclSAXFunc unparsedEntityDecl;
        setDocumentLocatorSAXFunc setDocumentLocator;
        startDocumentSAXFunc startDocument;
        endDocumentSAXFunc endDocument;
        startElementSAXFunc startElement;
        endElementSAXFunc endElement;
        referenceSAXFunc reference;
        charactersSAXFunc characters;
        ignorableWhitespaceSAXFunc ignorableWhitespace;
        processingInstructionSAXFunc processingInstruction;
        commentSAXFunc comment;
        warningSAXFunc warning;
        errorSAXFunc error;
        fatalErrorSAXFunc fatalError; /* unused error() get all the errors */
        getParameterEntitySAXFunc getParameterEntity;
        cdataBlockSAXFunc cdataBlock;
        externalSubsetSAXFunc externalSubset;
        int initialized;
    };

A SAX handler is bunch of callbacks called by the parser when processing of the input generate data or structure informations.

### xmlExternalEntityLoader ()

    xmlParserInputPtr (*xmlExternalEntityLoader)
                                                (const char *URL,
                                                 const char *ID,
                                                 xmlParserCtxtPtr context);

External entity loaders types.

`URL` : |
`ID` : |
`context` : |
Returns : |

### xmlInitParser ()

    void        xmlInitParser                   (void);

Initialization function for the XML parser. This is not reentrant. Call once before processing in case of use in multithreaded programs.

### xmlCleanupParser ()

    void        xmlCleanupParser                (void);

Cleanup function for the XML parser. It tries to reclaim all parsing related global memory allocated for the parser processing. It doesn't deallocate any document related memory. Calling this function should not prevent reusing the parser. One should call xmlCleanupParser() only when the process has finished using the library or XML document built with it.

### xmlParserInputRead ()

    int         xmlParserInputRead              (xmlParserInputPtr in,
                                                 int len);

This function refresh the input for the parser. It doesn't try to preserve pointers to the input buffer, and discard already read data

`in` : |
`len` : |
Returns : |

### xmlParserInputGrow ()

    int         xmlParserInputGrow              (xmlParserInputPtr in,
                                                 int len);

This function increase the input for the parser. It tries to preserve pointers to the input buffer, and keep already read data

`in` : |
`len` : |
Returns : |

### xmlStrdup ()

    xmlChar*    xmlStrdup                       (const xmlChar *cur);

a strdup for array of xmlChar's. Since they are supposed to be encoded in UTF-8 or an encoding with 8bit based chars, we assume a termination mark of '0'.

`cur` : |
Returns : |

### xmlStrndup ()

    xmlChar*    xmlStrndup                      (const xmlChar *cur,
                                                 int len);

a strndup for array of xmlChar's

`cur` : |
`len` : |
Returns : |

### xmlCharStrndup ()

    xmlChar*    xmlCharStrndup                  (const char *cur,
                                                 int len);

a strndup for char's to xmlChar's

`cur` : |
`len` : |
Returns : |

### xmlCharStrdup ()

    xmlChar*    xmlCharStrdup                   (const char *cur);

a strdup for char's to xmlChar's

`cur` : |
Returns : |

### xmlStrsub ()

    xmlChar*    xmlStrsub                       (const xmlChar *str,
                                                 int start,
                                                 int len);

Extract a substring of a given string

`str` : |
`start` : |
`len` : |
Returns : |

### xmlStrchr ()

    const xmlChar* xmlStrchr                    (const xmlChar *str,
                                                 xmlChar val);

a strchr for xmlChar's

`str` : |
`val` : |
Returns : |

### xmlStrstr ()

    const xmlChar* xmlStrstr                    (const xmlChar *str,
                                                 const xmlChar *val);

a strstr for xmlChar's

`str` : |
`val` : |
Returns : |

### xmlStrcasestr ()

    const xmlChar* xmlStrcasestr                (const xmlChar *str,
                                                 xmlChar *val);

a case-ignoring strstr for xmlChar's

`str` : |
`val` : |
Returns : |

### xmlStrcmp ()

    int         xmlStrcmp                       (const xmlChar *str1,
                                                 const xmlChar *str2);

a strcmp for xmlChar's

`str1` : |
`str2` : |
Returns : |

### xmlStrncmp ()

    int         xmlStrncmp                      (const xmlChar *str1,
                                                 const xmlChar *str2,
                                                 int len);

a strncmp for xmlChar's

`str1` : |
`str2` : |
`len` : |
Returns : |

### xmlStrcasecmp ()

    int         xmlStrcasecmp                   (const xmlChar *str1,
                                                 const xmlChar *str2);

a strcasecmp for xmlChar's

`str1` : |
`str2` : |
Returns : |

### xmlStrncasecmp ()

    int         xmlStrncasecmp                  (const xmlChar *str1,
                                                 const xmlChar *str2,
                                                 int len);

a strncasecmp for xmlChar's

`str1` : |
`str2` : |
`len` : |
Returns : |

### xmlStrEqual ()

    int         xmlStrEqual                     (const xmlChar *str1,
                                                 const xmlChar *str2);

Check if both string are equal of have same content Should be a bit more readable and faster than xmlStrEqual()

`str1` : |
`str2` : |
Returns : |

### xmlStrlen ()

    int         xmlStrlen                       (const xmlChar *str);

length of a xmlChar's string

`str` : |
Returns : |

### xmlStrcat ()

    xmlChar*    xmlStrcat                       (xmlChar *cur,
                                                 const xmlChar *add);

a strcat for array of xmlChar's. Since they are supposed to be encoded in UTF-8 or an encoding with 8bit based chars, we assume a termination mark of '0'.

`cur` : |
`add` : |
Returns : |

### xmlStrncat ()

    xmlChar*    xmlStrncat                      (xmlChar *cur,
                                                 const xmlChar *add,
                                                 int len);

a strncat for array of xmlChar's, it will extend `cur` with the len first bytes of `add`.

`cur` : |
`add` : |
`len` : |
Returns : |

### xmlParseDoc ()

    xmlDocPtr   xmlParseDoc                     (xmlChar *cur);

parse an XML in-memory document and build a tree.

`cur` : |
Returns : |

### xmlParseMemory ()

    xmlDocPtr   xmlParseMemory                  (const char *buffer,
                                                 int size);

parse an XML in-memory block and build a tree.

`buffer` : |
`size` : |
Returns : |

### xmlParseFile ()

    xmlDocPtr   xmlParseFile                    (const char *filename);

parse an XML file and build a tree. Automatic support for ZLIB/Compress compressed document is provided by default if found at compile-time.

`filename` : |
Returns : |

### xmlSubstituteEntitiesDefault ()

    int         xmlSubstituteEntitiesDefault    (int val);

Set and return the previous value for default entity support. Initially the parser always keep entity references instead of substituting entity values in the output. This function has to be used to change the default parser behavior SAX::substituteEntities() has to be used for changing that on a file by file basis.

`val` : |
Returns : |

### xmlKeepBlanksDefault ()

    int         xmlKeepBlanksDefault            (int val);

Set and return the previous value for default blanks text nodes support. The 1.x version of the parser used an heuristic to try to detect ignorable white spaces. As a result the SAX callback was generating ignorableWhitespace() callbacks instead of characters() one, and when using the DOM output text nodes containing those blanks were not generated. The 2.x and later version will switch to the XML standard way and ignorableWhitespace() are only generated when running the parser in validating mode and when the current element doesn't allow CDATA or mixed content. This function is provided as a way to force the standard behavior on 1.X libs and to switch back to the old mode for compatibility when running 1.X client code on 2.X . Upgrade of 1.X code should be done by using xmlIsBlankNode() commodity function to detect the "empty" nodes generated. This value also affect autogeneration of indentation when saving code if blanks sections are kept, indentation is not generated.

`val` : |
Returns : |

### xmlStopParser ()

    void        xmlStopParser                   (xmlParserCtxtPtr ctxt);

Blocks further parser processing

`ctxt` : |

### xmlPedanticParserDefault ()

    int         xmlPedanticParserDefault        (int val);

Set and return the previous value for enabling pedantic warnings.

`val` : |
Returns : |

### xmlLineNumbersDefault ()

    int         xmlLineNumbersDefault           (int val);

Set and return the previous value for enabling line numbers in elements contents. This may break on old application and is turned off by default.

`val` : |
Returns : |

### xmlRecoverDoc ()

    xmlDocPtr   xmlRecoverDoc                   (xmlChar *cur);

parse an XML in-memory document and build a tree. In the case the document is not Well Formed, a tree is built anyway

`cur` : |
Returns : |

### xmlRecoverMemory ()

    xmlDocPtr   xmlRecoverMemory                (const char *buffer,
                                                 int size);

parse an XML in-memory block and build a tree. In the case the document is not Well Formed, a tree is built anyway

`buffer` : |
`size` : |
Returns : |

### xmlRecoverFile ()

    xmlDocPtr   xmlRecoverFile                  (const char *filename);

parse an XML file and build a tree. Automatic support for ZLIB/Compress compressed document is provided by default if found at compile-time. In the case the document is not Well Formed, a tree is built anyway

`filename` : |
Returns : |

### xmlParseDocument ()

    int         xmlParseDocument                (xmlParserCtxtPtr ctxt);

parse an XML document (and build a tree if using the standard SAX interface).

[1] document ::= prolog element Misc*

[22] prolog ::= XMLDecl? Misc* (doctypedecl Misc*)?

`ctxt` : |
Returns : |

### xmlParseExtParsedEnt ()

    int         xmlParseExtParsedEnt            (xmlParserCtxtPtr ctxt);

parse a general parsed entity An external general parsed entity is well-formed if it matches the production labeled extParsedEnt.

[78] extParsedEnt ::= TextDecl? content

`ctxt` : |
Returns : |

### xmlSAXParseDoc ()

    xmlDocPtr   xmlSAXParseDoc                  (xmlSAXHandlerPtr sax,
                                                 xmlChar *cur,
                                                 int recovery);

parse an XML in-memory document and build a tree. It use the given SAX function block to handle the parsing callback. If sax is NULL, fallback to the default DOM tree building routines.

`sax` : |
`cur` : |
`recovery` : |
Returns : |

### xmlSAXUserParseFile ()

    int         xmlSAXUserParseFile             (xmlSAXHandlerPtr sax,
                                                 void *user_data,
                                                 const char *filename);

parse an XML file and call the given SAX handler routines. Automatic support for ZLIB/Compress compressed document is provided

`sax` : |
`user_data` : |
`filename` : |
Returns : |

### xmlSAXUserParseMemory ()

    int         xmlSAXUserParseMemory           (xmlSAXHandlerPtr sax,
                                                 void *user_data,
                                                 const char *buffer,
                                                 int size);

A better SAX parsing routine. parse an XML in-memory buffer and call the given SAX handler routines.

`sax` : |
`user_data` : |
`buffer` : |
`size` : |
Returns : |

### xmlSAXParseMemory ()

    xmlDocPtr   xmlSAXParseMemory               (xmlSAXHandlerPtr sax,
                                                 const char *buffer,
                                                 int size,
                                                 int recovery);

parse an XML in-memory block and use the given SAX function block to handle the parsing callback. If sax is NULL, fallback to the default DOM tree building routines.

`sax` : |
`buffer` : |
`size` : |
`recovery` : |
Returns : |

### xmlSAXParseMemoryWithData ()

    xmlDocPtr   xmlSAXParseMemoryWithData       (xmlSAXHandlerPtr sax,
                                                 const char *buffer,
                                                 int size,
                                                 int recovery,
                                                 void *data);

parse an XML in-memory block and use the given SAX function block to handle the parsing callback. If sax is NULL, fallback to the default DOM tree building routines.

User data (void *) is stored within the parser context in the context's _private member, so it is available nearly everywhere in libxml

`sax` : |
`buffer` : |
`size` : |
`recovery` : |
`data` : |
Returns : |

### xmlSAXParseFile ()

    xmlDocPtr   xmlSAXParseFile                 (xmlSAXHandlerPtr sax,
                                                 const char *filename,
                                                 int recovery);

parse an XML file and build a tree. Automatic support for ZLIB/Compress compressed document is provided by default if found at compile-time. It use the given SAX function block to handle the parsing callback. If sax is NULL, fallback to the default DOM tree building routines.

`sax` : |
`filename` : |
`recovery` : |
Returns : |

### xmlSAXParseFileWithData ()

    xmlDocPtr   xmlSAXParseFileWithData         (xmlSAXHandlerPtr sax,
                                                 const char *filename,
                                                 int recovery,
                                                 void *data);

parse an XML file and build a tree. Automatic support for ZLIB/Compress compressed document is provided by default if found at compile-time. It use the given SAX function block to handle the parsing callback. If sax is NULL, fallback to the default DOM tree building routines.

User data (void *) is stored within the parser context in the context's _private member, so it is available nearly everywhere in libxml

`sax` : |
`filename` : |
`recovery` : |
`data` : |
Returns : |

### xmlSAXParseEntity ()

    xmlDocPtr   xmlSAXParseEntity               (xmlSAXHandlerPtr sax,
                                                 const char *filename);

parse an XML external entity out of context and build a tree. It use the given SAX function block to handle the parsing callback. If sax is NULL, fallback to the default DOM tree building routines.

[78] extParsedEnt ::= TextDecl? content

This correspond to a "Well Balanced" chunk

`sax` : |
`filename` : |
Returns : |

### xmlParseEntity ()

    xmlDocPtr   xmlParseEntity                  (const char *filename);

parse an XML external entity out of context and build a tree.

[78] extParsedEnt ::= TextDecl? content

This correspond to a "Well Balanced" chunk

`filename` : |
Returns : |

### xmlParseDTD ()

    xmlDtdPtr   xmlParseDTD                     (const xmlChar *ExternalID,
                                                 const xmlChar *SystemID);

Load and parse an external subset.

`ExternalID` : |
`SystemID` : |
Returns : |

### xmlSAXParseDTD ()

    xmlDtdPtr   xmlSAXParseDTD                  (xmlSAXHandlerPtr sax,
                                                 const xmlChar *ExternalID,
                                                 const xmlChar *SystemID);

Load and parse an external subset.

`sax` : |
`ExternalID` : |
`SystemID` : |
Returns : |

### xmlIOParseDTD ()

    xmlDtdPtr   xmlIOParseDTD                   (xmlSAXHandlerPtr sax,
                                                 xmlParserInputBufferPtr input,
                                                 xmlCharEncoding enc);

Load and parse a DTD

`sax` : |
`input` : |
`enc` : |
Returns : |

### xmlParseBalancedChunkMemory ()

    int         xmlParseBalancedChunkMemory     (xmlDocPtr doc,
                                                 xmlSAXHandlerPtr sax,
                                                 void *user_data,
                                                 int depth,
                                                 const xmlChar *string,
                                                 xmlNodePtr *lst);

Parse a well-balanced chunk of an XML document called by the parser The allowed sequence for the Well Balanced Chunk is the one defined by the content production in the XML grammar:

[43] content ::= (element | CharData | Reference | CDSect | PI | Comment)*

`doc` : |
`sax` : |
`user_data` : |
`depth` : |
`string` : |
`lst` : |
Returns : |

### xmlParseBalancedChunkMemoryRecover ()

    int         xmlParseBalancedChunkMemoryRecover
                                                (xmlDocPtr doc,
                                                 xmlSAXHandlerPtr sax,
                                                 void *user_data,
                                                 int depth,
                                                 const xmlChar *string,
                                                 xmlNodePtr *lst,
                                                 int recover);

Parse a well-balanced chunk of an XML document called by the parser The allowed sequence for the Well Balanced Chunk is the one defined by the content production in the XML grammar:

[43] content ::= (element | CharData | Reference | CDSect | PI | Comment)*

`doc` : |
`sax` : |
`user_data` : |
`depth` : |
`string` : |
`lst` : |
`recover` : |
Returns : |

### xmlParseExternalEntity ()

    int         xmlParseExternalEntity          (xmlDocPtr doc,
                                                 xmlSAXHandlerPtr sax,
                                                 void *user_data,
                                                 int depth,
                                                 const xmlChar *URL,
                                                 const xmlChar *ID,
                                                 xmlNodePtr *lst);

Parse an external general entity An external general parsed entity is well-formed if it matches the production labeled extParsedEnt.

[78] extParsedEnt ::= TextDecl? content

`doc` : |
`sax` : |
`user_data` : |
`depth` : |
`URL` : |
`ID` : |
`lst` : |
Returns : |

### xmlParseCtxtExternalEntity ()

    int         xmlParseCtxtExternalEntity      (xmlParserCtxtPtr ctx,
                                                 const xmlChar *URL,
                                                 const xmlChar *ID,
                                                 xmlNodePtr *lst);

Parse an external general entity within an existing parsing context An external general parsed entity is well-formed if it matches the production labeled extParsedEnt.

[78] extParsedEnt ::= TextDecl? content

`ctx` : |
`URL` : |
`ID` : |
`lst` : |
Returns : |

### xmlInitParserCtxt ()

    void        xmlInitParserCtxt               (xmlParserCtxtPtr ctxt);

Initialize a parser context

`ctxt` : |

### xmlClearParserCtxt ()

    void        xmlClearParserCtxt              (xmlParserCtxtPtr ctxt);

Clear (release owned resources) and reinitialize a parser context

`ctxt` : |

### xmlFreeParserCtxt ()

    void        xmlFreeParserCtxt               (xmlParserCtxtPtr ctxt);

Free all the memory used by a parser context. However the parsed document in ctxt->myDoc is not freed.

`ctxt` : |

### xmlSetupParserForBuffer ()

    void        xmlSetupParserForBuffer         (xmlParserCtxtPtr ctxt,
                                                 const xmlChar *buffer,
                                                 const char *filename);

Setup the parser context to parse a new buffer; Clears any prior contents from the parser context. The buffer parameter must not be NULL, but the filename parameter can be

`ctxt` : |
`buffer` : |
`filename` : |

### xmlCreateDocParserCtxt ()

    xmlParserCtxtPtr xmlCreateDocParserCtxt     (xmlChar *cur);

Creates a parser context for an XML in-memory document.

`cur` : |
Returns : |

### xmlGetFeaturesList ()

    int         xmlGetFeaturesList              (int *len,
                                                 const char **result);

Copy at most *`len` feature names into the `result` array

`len` : |
`result` : |
Returns : |

### xmlGetFeature ()

    int         xmlGetFeature                   (xmlParserCtxtPtr ctxt,
                                                 const char *name,
                                                 void *result);

Read the current value of one feature of this parser instance

`ctxt` : |
`name` : |
`result` : |
Returns : |

### xmlSetFeature ()

    int         xmlSetFeature                   (xmlParserCtxtPtr ctxt,
                                                 const char *name,
                                                 void *value);

Change the current value of one feature of this parser instance

`ctxt` : |
`name` : |
`value` : |
Returns : |

### xmlCreatePushParserCtxt ()

    xmlParserCtxtPtr xmlCreatePushParserCtxt    (xmlSAXHandlerPtr sax,
                                                 void *user_data,
                                                 const char *chunk,
                                                 int size,
                                                 const char *filename);

Create a parser context for using the XML parser in push mode. If `buffer` and `size` are non-NULL, the data is used to detect the encoding. The remaining characters will be parsed so they don't need to be fed in again through xmlParseChunk. To allow content encoding detection, `size` should be >= 4 The value of `filename` is used for fetching external entities and error/warning reports.

`sax` : |
`user_data` : |
`chunk` : |
`size` : |
`filename` : |
Returns : |

### xmlParseChunk ()

    int         xmlParseChunk                   (xmlParserCtxtPtr ctxt,
                                                 const char *chunk,
                                                 int size,
                                                 int terminate);

Parse a Chunk of memory

`ctxt` : |
`chunk` : |
`size` : |
`terminate` : |
Returns : |

### xmlCreateIOParserCtxt ()

    xmlParserCtxtPtr xmlCreateIOParserCtxt      (xmlSAXHandlerPtr sax,
                                                 void *user_data,
                                                 xmlInputReadCallback ioread,
                                                 xmlInputCloseCallback ioclose,
                                                 void *ioctx,
                                                 xmlCharEncoding enc);

Create a parser context for using the XML parser with an existing I/O stream

`sax` : |
`user_data` : |
`ioread` : |
`ioclose` : |
`ioctx` : |
`enc` : |
Returns : |

### xmlNewIOInputStream ()

    xmlParserInputPtr xmlNewIOInputStream       (xmlParserCtxtPtr ctxt,
                                                 xmlParserInputBufferPtr input,
                                                 xmlCharEncoding enc);

Create a new input stream structure encapsulating the `input` into a stream suitable for the parser.

`ctxt` : |
`input` : |
`enc` : |
Returns : |

### xmlParserFindNodeInfo ()

    const xmlParserNodeInfo* xmlParserFindNodeInfo
                                                (const xmlParserCtxtPtr ctxt,
                                                 const xmlNodePtr node);

Find the parser node info struct for a given node

`ctxt` : |
`node` : |
Returns : |

### xmlInitNodeInfoSeq ()

    void        xmlInitNodeInfoSeq              (xmlParserNodeInfoSeqPtr seq);

-- Initialize (set to initial state) node info sequence

`seq` : |

### xmlClearNodeInfoSeq ()

    void        xmlClearNodeInfoSeq             (xmlParserNodeInfoSeqPtr seq);

-- Clear (release memory and reinitialize) node info sequence

`seq` : |

### xmlParserFindNodeInfoIndex ()

    unsigned long xmlParserFindNodeInfoIndex    (const xmlParserNodeInfoSeqPtr seq,
                                                 const xmlNodePtr node);

xmlParserFindNodeInfoIndex : Find the index that the info record for the given node is or should be at in a sorted sequence

`seq` : |
`node` : |
Returns : |

### xmlParserAddNodeInfo ()

    void        xmlParserAddNodeInfo            (xmlParserCtxtPtr ctxt,
                                                 const xmlParserNodeInfoPtr info);

Insert node info record into the sorted sequence

`ctxt` : |
`info` : |

### xmlSetExternalEntityLoader ()

    void        xmlSetExternalEntityLoader      (xmlExternalEntityLoader f);

Changes the defaultexternal entity resolver function for the application

`f` : |

### xmlGetExternalEntityLoader ()

    xmlExternalEntityLoader xmlGetExternalEntityLoader
                                                (void);

Get the default external entity resolver function for the application

Returns : |

### xmlLoadExternalEntity ()

    xmlParserInputPtr xmlLoadExternalEntity     (const char *URL,
                                                 const char *ID,
                                                 xmlParserCtxtPtr ctxt);

Load an external entity, note that the use of this function for unparsed entities may generate problems TODO: a more generic External entity API must be designed

`URL` : |
`ID` : |
`ctxt` : |
Returns : |

<<< Previous Page | Home | Up | Next Page >>>
Libxml Library Reference | xmlreader